checkRequire("Lua_DialogueBubbleItem");
checkRequire("Lua_ShopSubTypeItem");
checkRequire("Lua_ShopBtnItem");
Lua_ShopWindow = class("Lua_ShopWindow", Lua_Window);
function Lua_ShopWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/shop/xui_sd_bg_01.jpg";
	self.windowName = "Lua_ShopWindow";
	self.skinName = "ShopWindow_skin";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ShopWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("SHOP_MAINTYPE_SELECT", self, self.onShopMainTypeSelect);
	self:addLuaEvent("SHOP_SUBTYPE_SELECT", self, self.onShopSubTypeSelect);
	self:addLuaEvent("SHOP_TYPE_SELECT", self, self.onShopTypeSelect);
	self:addLuaEvent("REFRESH_SHOP_INFO", self, self.updateShopTypePanel); -- 到达商店刷新时间
end

function Lua_ShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.moneyItemArr = Array();
	
	self.winBg.anchorValue = 4;
	self.winBg.pivotValue = 4;
	self.listBg:SetDimensions(720, 821 + self.adaptHeight / 2);

	self.mainWidth = 120;
	self.mainHeight = 118;
	self.mainTypeList = Lua_DragList.new(self.content, 605, self.mainHeight, Lua_AxisDefine.Horizontal);
	self.mainTypeList:setListCell(Lua_ShopMainTypeItem, self.mainWidth, self.mainHeight, 1);
	self.mainTypeList:setRectAnchor(7);
	self.mainTypeList:setRectPivot(5);
	self.mainTypeList:setLocation(360, 53, 0);

	self.subTypeList = Lua_DragList.new(self.content, 665, 78, Lua_AxisDefine.Horizontal);
	self.subTypeList.callBackOwner = self;
	self.subTypeList.dragCallBack = self.updateArrowShow;
	self.subTypeList:setListCell(Lua_ShopSubTypeItem, 172, 78, 1);
	-- self.subTypeList:setRectAnchor(1);
	-- self.subTypeList:setLocation(0, -499, 0);
	self.subTypeList:setLocation(0, 220, 0);

	-- self.personEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/shangdian", "shangdian", 150, -410);
	-- self.personEff.anchorValue = 1;
	-- self.personEff.siblingIndex = 1;
	-- self.personEff:setScale(0.8, 0.8);
	self.personImg = UICreate.createImage(self.content, "/images/shop/xui_sd_bg_2.png", 100, 165, 0, 0);
	self.personImg.siblingIndex = 1;
	self.personImg:setScale(0.8, 0.8);

	local bubbleId, type = DataCenter.shopUtil:getBubbleIdAndType(self.classname);
	self.dialogueBubbleItem = Lua_DialogueBubbleItem.new(self.content, type);
	self.dialogueBubbleItem:setData(bubbleId);
end

function Lua_ShopWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.listBg:SetDimensions(720, 821 + self.adaptHeight / 2);
end

function Lua_ShopWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.shopUtil.openMainTypeArr;
	local index = 1;
	if type(param) == "number" then
		index = self:getMainType(arr, param);
	elseif type(param) == "table" and param.main_id ~= nil then
		index = self:getMainType(arr, param.main_id);
	end
	if param.sub_id ~= nil then
		self.isFuncPathSub = param.sub_id; -- 跳转二级页签
	end

	local width = self.mainWidth * arr:getSize();
	width = width > 605 and 605 or width;
	self.mainTypeList.canDrag = width > 605;
	self.mainTypeList:setContentRect(width > 605 and 605 or width, self.mainHeight, false);
	self.mainTypeList:setArrayData(arr);
	self.mainTypeList:moveToIndex(index, true, false);
	self.mainTypeList:setSelectClick(index);
	self.mainTypeList:setSelected(index);
end

function Lua_ShopWindow:getMainType(arr, mainType)
	for i = 1, arr:getSize() do
		if arr[i].id == mainType then
			return i;
		end
	end
	return 1;
end

function Lua_ShopWindow:onShopMainTypeSelect(mainData)
	if self.mainType == mainData.id then
		return;
	end
	self.mainType = mainData.id;

	local index = 1;
	local arr = mainData.subTypeArr;
	if self.isFuncPathSub then
		index = self:getSubType(arr, self.isFuncPathSub);
		self.isFuncPathSub = nil;
	else
		for i = 1, arr:getSize() do
			if arr[i].bOpened then
				if arr[i].bCheckAlliance then -- 公会特殊处理
					if DataCenter.roleData.league_id ~= 0 then
						index = i;
						break;
					end
				else
					index = i;
					break;
				end
			end
		end
	end
	self.subTypeList.canDrag = arr:getSize() > 3;
	self.subTypeList:setArrayData(arr);
	self.subTypeList:moveToIndex(index, true, false);
	self.subTypeList:setSelectClick(index);
end

function Lua_ShopWindow:getSubType(arr, subType)
	for i = 1, arr:getSize() do
		if arr[i].id == subType then
			return i;
		end
	end
	return 1;
end

function Lua_ShopWindow:onShopSubTypeSelect(data)
	if data == nil or data.id == DataCenter.shopData.subType then
		return;
	end
	DataCenter.shopData.subType = data.id;

	-- 设置选中
	local arr = self.subTypeList.showList;
	for i = 1, arr:getSize() do
		arr[i]:updateSelect();
	end

	self.winBgPath = data.winBg;
	self.winBg:setUrl(self.winBgPath);
	self.btnBg:setEnable(false);

	if data.childShop == nil or #data.childShop == 0 then
		if self.btnList ~= nil then
			self.btnList:dispose();
			self.btnList = nil;
		end
		if self.shopPanel ~= nil then
			self.shopPanel:dispose();
			self.shopPanel = nil;
		end
	elseif #data.childShop == 1 then
		if self.btnList ~= nil then
			self.btnList:setEnable(false);
		end
		local vo = DataCenter.shopUtil:getShopTypeVo(data.childShop[1]);
		self:onShopTypeSelect(vo);
	else
		self.btnArr = Array();
		local vo;
		local index = 1;
		for i = 1, #data.childShop do
			vo = DataCenter.shopUtil:getShopTypeVo(data.childShop[i]);
			if vo.shopType == DataCenter.shopData.shopType then
				index = i;
			end
			self.btnArr:add(vo);
		end
		if self.btnList == nil then
			self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
			self.btnList:setButtonCell(Lua_ShopBtnItem);
			self.btnList:setButtonItem(158, 49);
			-- self.btnList:setRectAnchor(1);
			-- self.btnList:setLocation(0, -581, 0);
			self.btnList:setLocation(0, 139, 0);
		end
		self.btnList:setData(self.btnArr);
		self.btnList.showList[index]:onPressClick();
		self.btnList:setEnable(true);

		self.btnBg:SetDimensions(self.btnArr:getSize() * 152 + 20, 54);
		self.btnBg:setEnable(true);
	end
end

function Lua_ShopWindow:onShopTypeSelect(data)
	if data == nil or self.shopType == data.shopType then
		return;
	end
	self.shopType = data.shopType;
	DataCenter.shopData.shopType = data.shopType;

	if self.shopPanel ~= nil then
		self.shopPanel:dispose();
		self.shopPanel = nil;
	end
	if self.shopPanel == nil then
		local showPanel = checkRequire(data.panelStr);
		self.shopPanel = showPanel.new(self.content);
		self.shopPanel:setRectAnchor(9);
		self.shopPanel:onScreenResize(self.adaptHeight);
	end
	self.shopPanel:setData(data);

	data.bOpenSpritShop = data.shopType == Lua_ShopData.SPIRIT_SHOP;
	local item;
	for i = 1, #data.moneyType do
		item = self.moneyItemArr[i];
		if item == nil then
			item = Lua_MoneyItem.new(self.content);
			item:setRectAnchor(1);
			item:setCanClick(true);
			self.moneyItemArr:add(item);
		end
		item:setLocation(439 - i * 190, -24, 0);
		item:setMoney(data.moneyType[i]);
	end
	Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(data.shopType);
end

function Lua_ShopWindow:updateArrowShow(curSubPos)
	self.leftArrowIcon:setEnable(curSubPos <= -178);
	self.rightArrowIcon:setEnable(curSubPos >= 178);
end

function Lua_ShopWindow:updateShopTypePanel()
	if self.shopType ~= nil then
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(self.shopType);
	end
end

function Lua_ShopWindow:dispose()
	if self.dialogueBubbleItem ~= nil then
		self.dialogueBubbleItem:dispose();
		self.dialogueBubbleItem = nil;
	end
	if self.subTypeList ~= nil then
		self.subTypeList:dispose();
		self.subTypeList = nil;
	end
	if self.personEff ~= nil then
		self.personEff:dispose();
		self.personEff = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.shopPanel ~= nil then
		self.shopPanel:dispose();
		self.shopPanel = nil;
	end
	DataCenter.shopData:dispose();
	self:superCall("dispose");
end










Lua_ShopMainTypeItem = class("Lua_ShopMainTypeItem", Lua_ListCell)
function Lua_ShopMainTypeItem:ctor(p)
	self:superCall("ctor", p, "ShopMainTypeItem_skin");
end

function Lua_ShopMainTypeItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("RedPoint_Update_State", self, self.checkRedPoint);
end

function Lua_ShopMainTypeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self:checkRedPoint();
end

function Lua_ShopMainTypeItem:onPressClick()
	-- if self._data and self._data.subTypeArr:getSize() > 0 then
		Lua_MsgUtil.callFunc("SHOP_MAINTYPE_SELECT", self._data);
		return true;
	-- else
	-- 	OperateAlert.show("功能未开启")
	-- end
end

function Lua_ShopMainTypeItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	if bSelect then
		self.itemBg:setAltas(self._data.iconAtlas, self._data.iconSelected);
	else
		-- if self._data and self._data.subTypeArr:getSize() > 0 then
			self.itemBg:setAltas(self._data.iconAtlas, self._data.iconNormal);
		-- else
		-- 	self.itemBg:setAltas(self._data.iconAtlas, self._data.iconUnOpen);
		-- end
	end
	self.selectIcon:setEnable(bSelect);
end

function Lua_ShopMainTypeItem:checkRedPoint()
	if self._data ~= nil and self._data.redDotState then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(46, 45, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ShopMainTypeItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end