Lua_ShopBtnItem = class("Lua_ShopBtnItem", Lua_ButtonCell);
function Lua_ShopBtnItem:ctor(p)
	self:superCall("ctor", p, "ShopBtnItem_skin");
end

function Lua_ShopBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.lockSp:setEnable(false);
	self.btnSp:addClickFuntion(self, self.onPressClick);
end

function Lua_ShopBtnItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	self.btnText.text = data.name;

	if not data:checkOpened() then
		self:setBtnGray();
	end

	if data.red_point_id ~= nil then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content, data.red_point_id);
			self.redPointIcon:setLocation(50, 10, 0);
		end
		self.redPointIcon:setEnable(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:setEnable(false);
		end
	end
end

function Lua_ShopBtnItem:onPressClick(go)
	if self.data == nil or not self.data:checkOpened() then
		local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(self.data.funcId);
		if vo.isOpen == false and vo.advanceMessage ~= "" then
			OperateAlert.show(vo.advanceMessage);
		else
			OperateAlert.showLangValue(125018);
		end
		return;
	end

	if self.data.redDotState then
		DataCenter.redPointData:updateRedPointState(self.data.red_point_id, false, true);
	end
	Lua_MsgUtil.callFunc("SHOP_TYPE_SELECT", self.data);

	self:superCall("onPressClick", go);
end

function Lua_ShopBtnItem:setSelected(index)
	if self.data ~= nil and not self.data:checkOpened() then
		self:setBtnGray();
		return;
	end

	if self.index == index then
		self.btnText.colorStr = Lua_ColorDefine.transColor("534945");
		self.btnSp.alpha = 1;
	else
		self.btnText.colorStr = Lua_ColorDefine.transColor("D0C9C0");
		self.btnSp.alpha = 0.01;
	end
	self.isSetGray = false;
end

function Lua_ShopBtnItem:setBtnGray()
	if not self.isSetGray then
		self.isSetGray = true;
		self.btnText.colorStr = Lua_ColorDefine.transColor("534945");
		self.btnSp.alpha = 1;
		self.btnText:setGray(true);
		self.btnSp:setGray(true);
	end
end

function Lua_ShopBtnItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end