Lua_ShopSubTypeItem = class("Lua_ShopSubTypeItem", Lua_ListCell);
function Lua_ShopSubTypeItem:ctor(p)
	self:superCall("ctor", p, "ShopTypeItem_skin");
end

function Lua_ShopSubTypeItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("RedPoint_Update_State", self, self.updateRedPoint);
end

function Lua_ShopSubTypeItem:updateRedPoint(id)
	if self.data ~= nil and self.data.redDotIdArr:indexOf(id) ~= -1 then
		self:setRedPoint();
	end
end

function Lua_ShopSubTypeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.isOpened = data.bOpened;
	self.bCheckAlliance = data.bCheckAlliance;
	self.isJoinAlliance = DataCenter.roleData.league_id ~= 0;

	local isGray = false;
	if self.isOpened then
		-- if self.bCheckAlliance then
		-- 	isGray = not self.isJoinAlliance;
		-- end
	else
		isGray = true;
	end
	self.btnSp:setGray(isGray);
	self.shopNameTxt:setGray(isGray);

	self:updateSelect();
	self:setRedPoint();
end

function Lua_ShopSubTypeItem:updateSelect()
	if self.data == nil then
		return;
	end

	if self.data.id == DataCenter.shopData.subType then
		self.btnSp:setAltas("shop_atlas_1", "xui_sd_tab_1_s");
		self.btnSp:setLocation(-86, -27, 0);
		self.shopNameTxt.colorStr = Lua_ColorDefine.transColorStr("48413B");
		self.shopNameTxt.fontSize = 30;
		self.shopNameTxt:setLocation(0, 0, 0);
    else
    	self.btnSp:setAltas("shop_atlas_1", "xui_sd_tab_1");
		self.btnSp:setLocation(-76, -27, 0);
		self.shopNameTxt.colorStr = Lua_ColorDefine.transColorStr("F7F5EE");
		self.shopNameTxt.fontSize = 28;
		self.shopNameTxt:setLocation(2, -2, 0);
    end
    self.shopNameTxt.text = self.data.name;
    self.btnSp:resetSize();
end

function Lua_ShopSubTypeItem:setRedPoint()
	local state = self.data ~= nil and self.data.redDotState;
	if state then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(70, 20, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ShopSubTypeItem:onPressClick()
	if self.data == nil then
		return;
	end

	if self.isOpened then
		-- if self.bCheckAlliance and not self.isJoinAlliance then
		-- 	OperateAlert.showLangValue(125023);
		-- 	return;
		-- end
	else
		self.data:showFuncAdvance();
		return;
	end

	if self.data.redDotState then
		local arr = self.data.redDotIdArr;
		if arr ~= nil and arr:getSize() == 1 then
			DataCenter.redPointData:updateRedPointState(arr[1], false, true);
		end
	end

	Lua_MsgUtil.callFunc("SHOP_SUBTYPE_SELECT", self.data);
end

function Lua_ShopSubTypeItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end