checkRequire("Lua_SpiritShopItem");
Lua_SpiritShopSecondItem = class("Lua_SpiritShopSecondItem", Lua_ListCell);
function Lua_SpiritShopSecondItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SpiritShopSecondItem:buildShowItem()
	self:superCall("buildShowItem");

	self.shopItemArr = Array();
	self.bottomBg = UICreate.createUIAtlasImage(self.content, "shop_atlas_2", "xui_sd_window_2", 0, -114, 0, 0);
end

function Lua_SpiritShopSecondItem:setData(data)
	if data == nil then
		return;
	end

	self.showNum = data:getSize();
	local count = self.shopItemArr:getSize();
	local len = self.showNum > count and self.showNum or count;
	local item;
	for i = 1, len do
		if i > count then
			item = Lua_SpiritShopItem.new(self.content);
			self.shopItemArr:add(item);
		else
			item = self.shopItemArr[i];
		end

		if i <= self.showNum then
			data[i].highlightEff = "ui_tmd_shuaxin";
			item:setData(data[i]);
			item:setLocation(-226 + (i - 1) * 226, -6, 0);
			item:setEnable(true);
		else
			item:setEnable(false);
		end
	end
end

function Lua_SpiritShopSecondItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	local item;
	for i = 1, self.showNum do
		item = self.shopItemArr[i];
		if item ~= nil and item:checkInBound(winPos.x, winPos.y) then
			item:onPressClick();
			break;
		end
	end
end

function Lua_SpiritShopSecondItem:dispose()
	if self.bottomBg ~= nil then
		self.bottomBg:dispose();
		self.bottomBg = nil;
	end
	if self.shopItemArr ~= nil then
		self.shopItemArr:dispose();
		self.shopItemArr = nil;
	end
	self:superCall("dispose");
end